//
//  dvdpalace.m
//  dvdpalace
//
//  Created by Conor Dearden on Sat May 22 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "discshop.h"

@implementation discshop

+ (id)plugin;
{ 
    return [[[self alloc] init] autorelease];
}


- (id)init {
	if (self = [super init]) {
		searchString = [[NSMutableString alloc] init];
		resultsTitle = [[NSMutableArray array] retain];
		resultsURL = [[NSMutableArray array] retain];
	}
	return self;
}

- (void)dealloc {
	[searchString release];
	[resultsTitle release];
	[resultsURL release];
	[super dealloc];
}

- (NSArray *)resultsTitles {
	return resultsTitle;
}


- (void)searchFor:(NSDictionary *)searchDict sender:(id)sender{
	messageTarget = sender;
	[resultsTitle removeAllObjects];
	[resultsURL removeAllObjects];
	
	[searchString deleteCharactersInRange:NSMakeRange(0, [searchString length])];
	
	
	if ([searchDict objectForKey:@"keyword"]) {
		[searchString setString:[searchDict objectForKey:@"keyword"]];
	}
	else if ([searchDict objectForKey:@"upc"] != nil) {
		[searchString setString:[searchDict objectForKey:@"upc"]];
	}
	else if ([searchDict objectForKey:@"title"] != nil) {
		[searchString setString:[searchDict objectForKey:@"title"]];
	}
	else {
		[messageTarget searchReturnedNumberOfResults:0 sender:self];
		return;
	}
	
	[searchString replaceOccurrencesOfString:@" " withString:@"+" options:NSLiteralSearch range:NSMakeRange(0, [searchString length])];
	NSString *searchStringEncoded = [searchString stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
	
	
	// Title
	//http://www.discshop.se/advanced_search.php?title=love&keyword_1=&media_type=bluray&action=search&type=movies
	
	// title
	//http://www.discshop.se/advanced_search.php?title=love&action=search&type=movies
	
	// Bluray
	//http://www.discshop.se/advanced_search.php?keyword_1=love&media_type=bluray&action=search&type=movies
	
	//http://www.discshop.se/search.php?q=love+actually
	
	// EAN
	//http://www.discshop.se/search.php?q=7391772396501

	/*
	// Ean search sample http://www.discshop.se/shop/ds_produkt.php?ean=7391772396501
	NSString *searchURL;
	if ([searchString length] == 13 && [searchString intValue] > 99999999) {
		searchURL = [NSString stringWithFormat:@"http://www.discshop.se/shop/ds_produkt.php?ean=%@", searchString];
		eanSearchURL = [searchURL retain];
	}
	else {

		//searchURL = [NSString stringWithFormat:@"http://www.discshop.se/shop/search_qs.php?ref=&subsite=start&lang=se&soktext=%@&x=0&y=0&sok_typ=titel",  searchStringEncoded];
		
		searchURL = [NSString stringWithFormat:@"http://www.discshop.se/shop/search_result.php?ref=&subsite=movies&lang=se&titel=%@&format%%5B0%%5D=1&format%%5B3%%5D=1&format%%5B4%%5D=1&sok_typ=advanced", searchStringEncoded];
	}
	 */
	
	NSString *searchURL = [NSString stringWithFormat:@"http://www.discshop.se/search.php?q=%@", searchStringEncoded];
	
	//NSLog(@"search: %@", searchURL);
		
    NSMutableURLRequest* post = [NSMutableURLRequest requestWithURL: [NSURL URLWithString:searchURL]];
	
	theConnection=[[NSURLConnection alloc] initWithRequest:post delegate:self];
	if (theConnection) {
		receivedData=[[NSMutableData data] retain];
	}
	else {
		[messageTarget searchReturnedNumberOfResults:0 sender:self];
	}
}


- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
	//redirects and such
    [receivedData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    // append the new data to the receivedData
    [receivedData appendData:data];
}

- (void)connection:(NSURLConnection *)connection 
  didFailWithError:(NSError *)error
{

    // release the connection, and the data object
    [connection release];
    [receivedData release];
	receivedData = nil;
	
	[messageTarget searchReturnedNumberOfResults:0 sender:self];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{

	NSString *results = [[[NSString alloc] initWithData:receivedData encoding:NSISOLatin1StringEncoding] autorelease];
	
	//NSLog(@"%@", results);

    // release the connection, and the data object
    [connection release];
    [receivedData release];
	receivedData = nil;
		
	//single result	
	if (results) {
		if ([results rangeOfString:@"og:title"].location != NSNotFound){
			
			NSString *title = [results stringBetween:@"content=\"" and:@"\"" startingFrom:@"og:title"];
			NSString *url = [results stringBetween:@"content=\"" and:@"\"" startingFrom:@"og:url"];
			
			if (title && url) {
				[resultsTitle addObject:[title stringByCleaningHTML]];
				[resultsURL addObject:url];
			}
		}
		else {
			NSArray *possibleURL = [results stringsBetween:@"class=\"ps" and:@"</div>"];
			NSEnumerator *enumURLs = [possibleURL objectEnumerator];
			NSString *nextURL;
			while (nextURL = [enumURLs nextObject]) {
				
				NSString *theURL = [nextURL stringBetween:@"href=\"" and:@"\""]; 
				NSString *title = [nextURL stringBetween:@"alt=\"" and:@"\""];
				if (theURL && title
					&& [theURL rangeOfString:@"http://www.discshop.se/filmer" options:NSCaseInsensitiveSearch | NSAnchoredSearch].location != NSNotFound) {
					//title = [title stringByCleaningHTML];
					[resultsTitle addObject:title];
					[resultsURL addObject:theURL];
				}
			}
		}
	}
	
	[messageTarget searchReturnedNumberOfResults:[resultsURL count] sender:self];
}


- (NSDictionary *)resultNumber:(int)number {
	
	NSMutableDictionary *returnData = [NSMutableDictionary dictionaryWithCapacity:10];
	
	NSString *results;
	
	if (number >= [resultsURL count]) {
		NSLog(@"Error: discshop requested out of range: %d of %d", number, [resultsURL count]);
		[returnData setObject:@"No data found on discshop.se" forKey:@"title"];
		return returnData;	
	}
	
	//NSLog(@"THe URL: %@", [resultsURL objectAtIndex:number]);
	NSString *stringURL = [resultsURL objectAtIndex:number];
	NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:stringURL] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:15.0];
	
	results = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
	
	if (results == nil)
		return nil;
			
	[returnData setValue:stringURL forKey:@"url"];
	[returnData setValue:[resultsTitle objectAtIndex:number] forKey:@"title"];

	
	NSString *cover = [results stringBetween:@"/img/omslag/front_large/" and:@"\""];
	if (cover) {
		cover = [@"http://www.discshop.se/img/omslag/front_large/" stringByAppendingString:cover];	
		[returnData setValue:cover forKey:@"imageLocation"];
	}
	else {
		cover = [results stringBetween:@"content=\"" and:@"\"" startingFrom:@"og:image"];
		if (cover) {
			cover = [@"http://www.discshop.se" stringByAppendingString:cover];		
			[returnData setValue:cover forKey:@"imageLocation"];
		}
	}
	
	
	NSString *tempString = [results stringBetween:@"<b>Orginal titel" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"originalTitle"];
	}
	
	tempString = [results stringBetween:@"<b>Produktionsland" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"country"];
	}
	
	tempString = [results stringBetween:@"</b>" and:@"</p>" startingFrom:@"<b>Premi"];
	//tempString = [results stringBetween:@"<b>Premiärår" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		NSDateFormatter *dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];		
		[dateFormatter setDateFormat:@"yyyy"];	
		
		NSDate *releaseDate = [dateFormatter dateFromString:tempString];
		if (releaseDate)
			[returnData setObject:releaseDate forKey:@"theatrical"];
	}
	
	tempString = [results stringBetween:@"<b>Releasedatum" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		NSDateFormatter *dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];		
		[dateFormatter setDateFormat:@"yyyy-mm-dd"];	
		
		NSDate *releaseDate = [dateFormatter dateFromString:tempString];
		if (releaseDate)
			[returnData setObject:releaseDate forKey:@"releaseDate"];
	}
	
	tempString = [results stringBetween:@"<b>Format" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		NSUInteger location = [tempString rangeOfString:@"Region "].location;
		if (location != NSNotFound) {
			tempString = [tempString substringFromIndex:location + 7];
			[returnData setValue:tempString forKey:@"region"];
		}
	}
	
	tempString = [results stringBetween:@"<b>EAN-kod" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"upc"];
	}
	
	tempString = [results stringBetween:@"<b>Speltid" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"duration"];
	}
	
	
	tempString = [results stringBetween:@"<b>TV-system" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"videoFormat"];
	}

	tempString = [results stringBetween:@"<b>Filmbolag" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"studio"];
	}
	else {
		tempString = [results stringBetween:@"</b>" and:@"</p>" startingFrom:@"</b>Distribut"];
		if (tempString) {
			tempString = [tempString stringByCleaningHTML];
			[returnData setValue:tempString forKey:@"studio"];
		}
	}
	
	tempString = [results stringBetween:@"</b>" and:@"</p>" startingFrom:@"</b>Åldersgr"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"rated"];
	}
	
	tempString = [results stringBetween:@"<b>Antal skivor" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"discs"];
	}
	
	tempString = [results stringBetween:@"<b>Genre</b><br/>" and:@"</p>"];
	if (tempString) {
		if ([tempString hasSuffix:@"<br/>"])
			tempString = [tempString substringToIndex:[tempString length] - 5];
		tempString = [tempString stringByReplacingOccurrencesOfString:@"<br/>" withString:@", "];
		[returnData setValue:tempString forKey:@"genre"];
	}
	
	
	tempString = [results stringBetween:@"<b>Regi" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"director"];
	}
	
	tempString = [results stringBetween:@"<b>Manus" and:@"</p>"];
	if (tempString) {
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"writer"];
	}
	
	
	tempString = [results stringBetween:@"<b>Textning</b><br/>" and:@"</p>"];
	if (tempString) {
		if ([tempString hasSuffix:@"<br/>"])
			tempString = [tempString substringToIndex:[tempString length] - 5];
		tempString = [tempString stringByReplacingOccurrencesOfString:@"<br/>" withString:@", "];
		[returnData setValue:tempString forKey:@"subtitles"];
	}
	
	
	tempString = [results stringBetween:@"<b>Ljud</b><br/>" and:@"<"];
	if (tempString) {
		NSUInteger location = [tempString rangeOfString:@"("].location;
		NSUInteger closeLocation = [tempString rangeOfString:@")"].location;
		if (location != NSNotFound && closeLocation != NSNotFound) {
			tempString = [tempString substringWithRange:NSMakeRange(location + 1, closeLocation - ( location + 1))];
		}
		
		[returnData setValue:tempString forKey:@"sound"];
	}
	
	
	tempString = [results stringBetween:@"<b>Bild</b><br/>" and:@"<"];
	if (tempString) {
		NSUInteger location = [tempString rangeOfString:@" ("].location;
		if (location != NSNotFound) {
			tempString = [tempString substringToIndex:location];
		}
		
		[returnData setValue:tempString forKey:@"aspectRatio"];
	}
	
	tempString = [results stringBetween:@"<b>Extra material</b><br/>" and:@"</p>"];
	if (tempString) {
		if ([tempString hasSuffix:@"<br/>"])
			tempString = [tempString substringToIndex:[tempString length] - 5];

		NSMutableString *cleanString = [NSMutableString stringWithString:tempString];		
		[cleanString replaceOccurrencesOfString:@"<br/>" withString:@"\n" options:NSCaseInsensitiveSearch	range:NSMakeRange(0,[cleanString length])];
		
		[returnData setValue:cleanString forKey:@"features"];
	}			
	
	
	tempString = [results stringBetween:@">" and:@"</div>" startingFrom:@"desc_long"];
	if (tempString) {
		NSMutableString *cleanString = [NSMutableString stringWithString:tempString];		
		[cleanString replaceOccurrencesOfString:@"</p>" withString:@"\n" options:NSCaseInsensitiveSearch	range:NSMakeRange(0,[cleanString length])];
		
		[returnData setValue:[cleanString stringByCleaningHTML] forKey:@"summary"];
	}
		
	
	NSMutableArray *creditsArray = [NSMutableArray array];
	tempString = [results stringBetween:@"espelare</b><br/>" and:@"</p>"];
	if (tempString) {
		NSArray *possibleActors = [tempString stringsBetween:@"<a " and:@"</a"];
		NSEnumerator *enumActors = [possibleActors objectEnumerator];
		NSString *nextActor;
		while (nextActor = [enumActors nextObject]) {
			
			NSString *actor = [nextActor stringBetween:@">" and:@"<"]; 
			if (actor) {
				[creditsArray addObject:[NSDictionary dictionaryWithObjectsAndKeys:actor, @"name", nil]];
			}
		}
		
		if ([creditsArray count])
			[returnData setObject:creditsArray forKey:@"credits"];
	}		
	
	
	
	tempString = [results stringBetween:@"rev_quick\"" and:@"</div>"];
	NSArray *stars = [tempString stringsBetween:@"i16_rate_10" and:@">"];
	NSArray *halfstars = [tempString stringsBetween:@"i16_rate_03" and:@">"];
	//NSArray *halfstars = [tempString stringsBetween:@"i16_rate_03" and:@">"];
	
	NSUInteger starsInt = [stars count];
	if (starsInt != 0 ) {
		if ([halfstars count]) {
			[returnData setObject:[NSString stringWithFormat:@"%d.5", starsInt] forKey:@"rating"];
		}
		else 
			[returnData setObject:[NSString stringWithFormat:@"%d", starsInt] forKey:@"rating"];
	}
	
	
	tempString = [results stringBetween:@"i16_osc\"></i>" and:@"</"];
	if (tempString) {		
		tempString = [tempString stringByCleaningHTML];
		[returnData setValue:tempString forKey:@"awards"];
	}	
	
	return returnData;	
}

@end
